Imports System.Net


Public Class AsynchCalcPi
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents piTextBox As System.Windows.Forms.TextBox
    Friend WithEvents panel1 As System.Windows.Forms.Panel
    Friend WithEvents calcButton As System.Windows.Forms.Button
    Friend WithEvents digitsUpDown As System.Windows.Forms.NumericUpDown
    Friend WithEvents label1 As System.Windows.Forms.Label
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.piTextBox = New System.Windows.Forms.TextBox()
        Me.panel1 = New System.Windows.Forms.Panel()
        Me.calcButton = New System.Windows.Forms.Button()
        Me.digitsUpDown = New System.Windows.Forms.NumericUpDown()
        Me.label1 = New System.Windows.Forms.Label()
        Me.panel1.SuspendLayout()
        CType(Me.digitsUpDown, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.SuspendLayout()
        '
        'piTextBox
        '
        Me.piTextBox.Dock = System.Windows.Forms.DockStyle.Fill
        Me.piTextBox.Location = New System.Drawing.Point(0, 40)
        Me.piTextBox.Multiline = True
        Me.piTextBox.Name = "piTextBox"
        Me.piTextBox.ScrollBars = System.Windows.Forms.ScrollBars.Vertical
        Me.piTextBox.Size = New System.Drawing.Size(232, 126)
        Me.piTextBox.TabIndex = 3
        Me.piTextBox.Text = "3"
        '
        'panel1
        '
        Me.panel1.Controls.AddRange(New System.Windows.Forms.Control() {Me.calcButton, Me.digitsUpDown, Me.label1})
        Me.panel1.Dock = System.Windows.Forms.DockStyle.Top
        Me.panel1.Name = "panel1"
        Me.panel1.Size = New System.Drawing.Size(232, 40)
        Me.panel1.TabIndex = 2
        '
        'calcButton
        '
        Me.calcButton.Location = New System.Drawing.Point(144, 8)
        Me.calcButton.Name = "calcButton"
        Me.calcButton.TabIndex = 2
        Me.calcButton.Text = "Calc"
        '
        'digitsUpDown
        '
        Me.digitsUpDown.Location = New System.Drawing.Point(80, 8)
        Me.digitsUpDown.Maximum = New Decimal(New Integer() {10000, 0, 0, 0})
        Me.digitsUpDown.Name = "digitsUpDown"
        Me.digitsUpDown.Size = New System.Drawing.Size(56, 20)
        Me.digitsUpDown.TabIndex = 1
        '
        'label1
        '
        Me.label1.Location = New System.Drawing.Point(8, 8)
        Me.label1.Name = "label1"
        Me.label1.Size = New System.Drawing.Size(64, 23)
        Me.label1.TabIndex = 0
        Me.label1.Text = "Digits of Pi"
        '
        'AsynchCalcPi
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(232, 166)
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.piTextBox, Me.panel1})
        Me.Name = "AsynchCalcPi"
        Me.Text = "AsynchCalcPi"
        Me.panel1.ResumeLayout(False)
        CType(Me.digitsUpDown, System.ComponentModel.ISupportInitialize).EndInit()
        Me.ResumeLayout(False)

    End Sub

#End Region

    Public Enum CalcState
        Pending
        Calculating
        Canceled
    End Enum

    Public state As CalcState = CalcState.Pending
    Dim service As localhost.CalcPiService = New localhost.CalcPiService()


    Private Sub calcButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles calcButton.Click
        Select Case state
            ' start a new calculation
        Case CalcState.Pending
                state = CalcState.Calculating
                calcButton.Text = "Cancel"

                ' Start web service request
                service.BeginCalcPi(CInt(digitsUpDown.Value), New AsyncCallback(AddressOf PiCalculated), Nothing)

                ' cancel a running calculation
            Case CalcState.Calculating
                state = CalcState.Canceled
                calcButton.Enabled = False
                service.Abort() ' Fail all outstanding requests

                ' Shouldn't be able to press calc button while it's canceling
            Case CalcState.Canceled
                Debug.Assert(False)

        End Select
    End Sub

    Delegate Sub ShowPiDelegate(ByVal pi As String)

    Public Sub ShowPi(ByVal pi As String)
        If Me.InvokeRequired = False Then
            piTextBox.Text = pi
            state = CalcState.Pending
            calcButton.Text = "Calc"
            calcButton.Enabled = True
        Else
            Dim delShowPi As ShowPiDelegate = New ShowPiDelegate(AddressOf ShowPi)
            Me.BeginInvoke(delShowPi, New Object() {pi})
        End If
    End Sub

    Public Sub PiCalculated(ByVal res As IAsyncResult)
        Try
            ShowPi(service.EndCalcPi(res))
        Catch ex As WebException
            ShowPi(ex.Message)
        End Try
    End Sub
End Class
